program maxc2dbf;
{$X+}
uses dos;
type
 String255 = string[255];
 String9 = String[9];
 String15 = string[15];
 string80 = string[80];
 string3 = string[3];
 string7 = string[7];
 string10 = string[10];
 string12 = string[12];
 string20 = string[20];
 string40 = string[40];


  Metals = array[1..9] of string3;
  Hs     = array[1..4] of real;
  MLs    = array[1..9] of real;
  MHLs   = array[1..9] of real;
  dHs    = array[1..4] of real;
  dHMCs  = array[1..2,1..9] of real;
  Cmnts  = array[1..9] of string20;

  Kon = array[1..6,1..16] of double;

  KonRec =
    Record
      Chelator : string7;
      H        : Hs;
      dHC      : dHs;
      Metal    : Metals;
      ML       : MLs;
      MHL      : MHLs;
      dHMC     : dHMCs;
      Comments : Cmnts;
    END;


  header = record
   fnm : array[1..10] of char;
   jk1 : byte;
   ftp : char;   {field type}
   jk2 : array[1..4] of byte;
   fln : byte;   {field width}
   dpl : byte;   {dec places}
   jk3 : array[1..14] of byte;
  end;

  dbf = record
   ver : byte;
   yer : byte;
   mon : byte;
   day : byte;
   num : longint;
   hnm : integer;
   rln : integer;
   wst : array[1..20] of byte;
   hd  : array[1..15] of header;
   jk4 : byte;
  end;

  string25 = string[25];
  string24 = string[24];

const
  X : array[1..15] of byte = (25,9,9,9,9,9,9,9,9,3,9,9,9,9,24);
  T : array[1..15] of char = ('C','N','N','N','N',
                              'N','N','N','N','C',
                              'N','N','N','N','C');

var dataf2 : file; data : dbf;
    ccm : file of konrec;
    ccmr : array[1..12] of konrec;
    OFN,IFN : string80;
    G : array[1..161] of char;
    RN2 : integer;



 FUNCTION Rpt(Strng : String80; Rp : Integer): string80;
 VAR
  I : Integer;
  S : String80;
 BEGIN
   S := '';
   IF Rp > 0 THEN
   BEGIN
     IF length(Strng) = 1 THEN
       BEGIN
         fillchar(S[1], Rp, ord(Strng[1]));
         S[0] := chr(Rp);
       END
       ELSE
        BEGIN
          IF length(Strng) <> 0 THEN
            FOR I := 1 to Rp DO
              S := concat(S, Strng);
        END;
   END;
   Rpt := S;
 END; {Rpt}



function CCM2DBF:boolean;
  var
    DBBuf : array[1..15] of string80;
    I,J,K : integer;
    num : string9;

    procedure pkg;
    var B,C,D : integer; L : array[1..15] of byte;
    begin
     for B := 1 to data.rln do
      G[B] := #32;
     D := 1;
     for B := 1 to 15 do
      begin
       L[B] := length(DBBuf[B]);
       if L[B] > X[B] then DBBuf[B][0] := chr(X[B]);
       L[B] := length(DBBuf[B]);
       if L[B] < X[B] then
         for C := 1 to (X[B]-L[B]) do
          DBBuf[B] := DBBuf[B] + #32;
       for C := 1 to X[B] do
        G[C+D] := DBBuf[B][C];
       D := D+X[B];
      end;
    end;

   begin

    CCM2DBF := false;
    for i := 1 to 12 do
     begin

      DBBuf[1] := ccmr[i].chelator;
      for K := 1 to 4 do
       begin
        str(ccmr[i].h[k]:9:3,DBBuf[K+1]);
        str(ccmr[i].dhc[k]:9:3,DBBuf[K+5]);
       end;

      for j := 1 to 9 do
       begin
        DBBuf[10] := ccmr[i].metal[j];
        str(ccmr[i].ml[j]:9:3,DBBuf[11]);
        str(ccmr[i].mhl[j]:9:3,DBBuf[12]);
        str(ccmr[i].dhmc[1,j]:9:3,DBBuf[13]);
        str(ccmr[i].dhmc[2,j]:9:3,DBBuf[14]);
        DBBuf[15] := ccmr[i].comments[j];
        pkg;
        blockwrite(dataf2,G,data.rln);
       end;
     end;

    CCM2DBF := true;

  end;


procedure padheader;
type string10 = string[10];
var regs : registers; year : integer; B,C : byte;
    FN : array[1..15] of string10;
begin

 regs.ah := $2A;
 Intr($21,regs);

 data.ver := 3;
 year := regs.cx - 1900;
 data.yer := year;
 data.mon := regs.dh;
 data.day := regs.dl;
 data.num := 108; {number of records = 12*9}
 data.hnm := 513; {15*32 + 32 + 1}
 data.rln := 161; {length of data string + 1}
 for B := 1 to 20 do
  data.wst[b] := 0;
 data.jk4 := 13;
{ data.jk4 := 32;}

 FN[1] :=  'CHELATOR'+#0+#0;  {all strings must be length 10}
 FN[2] :=  'H1'+rpt(#0,8);
 FN[3] :=  'H2'+rpt(#0,8);
 FN[4] :=  'H3'+rpt(#0,8);
 FN[5] :=  'H4'+rpt(#0,8);
 FN[6] :=  'DH1'+rpt(#0,7);
 FN[7] :=  'DH2'+rpt(#0,7);
 FN[8] :=  'DH3'+rpt(#0,7);
 FN[9] :=  'DH4'+rpt(#0,7);
 FN[10] := 'METAL'+rpt(#0,5);
 FN[11] := 'ML'+rpt(#0,8);
 FN[12] := 'MHL'+rpt(#0,7);
 FN[13] := 'DML'+rpt(#0,7);
 FN[14] := 'DMHL'+rpt(#0,6);
 FN[15] := 'COMMENTS'+#0+#0;

 with data do
  begin
   for B := 1 to 15 do
    for C := 1 to 10 do
     hd[B].fnm[C] := FN[B][C];
   for B := 1 to 15 do
    begin
     hd[B].jk1 := 0;
     for C := 1 to 4 do
      begin
       hd[B].jk2[C] := 0;
       hd[B].jk3[C] := 0;
      end;
    end;

   for B := 1 to 15 do
   begin
    hd[B].fln := X[B];
    hd[B].ftp := T[B];
    hd[B].dpl := 0;
   end;
   for B := 2 to 9 do
    hd[b].dpl := 3;
   for B := 11 to 14 do
    hd[b].dpl := 3;

   blockwrite(dataf2, data, 513);

  end;
end;



var c: word;

begin

   write('NAME OF MAXC CONSTANTS FILE TO CONVERT? ');
   readln(IFN);
   assign(ccm,IFN);
   {$I-}
   reset(ccm);
   {$I+}
   if IOResult <> 0 then
    begin
     writeln(IFN, ' FILE NOT FOUND OR UNABLE TO OPEN');
     exit;
    end;
   for rn2 := 1 to 12 do
    read(ccm,ccmr[rn2]);
   close(ccm);

   write('NAME OF DBASEIII FILE TO SAVE TO? ');
   readln(OFN);
   assign(dataf2,OFN);
   {$I-}
   rewrite(dataf2,1);
   {$I+}
   if IOResult <> 0 then
    begin
     writeln('UNABLE TO CREATE DBase FILE');
     exit;
    end;
   padheader;
   if NOT CCM2DBF then EXIT;
   close(dataf2);
   writeln('SUCCESSFUL');

end.
